* MENUFNCT.PRG
 
* This program Copyright, 1987 by Rick Dexter.   All Rights Reserved.
* See MENUFNCT.DOC for more information
*
* version 1.0   June 27, 1987
*

PROCEDURE init
* initialize system for ring menus by calculting spacing, window 
* sizes, print the top ring, and set up some variables

do SETMAIN
do SETWINS
w.close
clear
do PRNTMAIN

PUBLIC cur_menu, cur_bar, win_name, choice, numsubs
cur_menu = '1'
cur_bar = 1
w.select 1
store 'menu'+cur_menu TO win_name
w.use &win_name
return



PROCEDURE setmain
* sets the top line of the menu according to how many options exist

PUBLIC options
PUBLIC numopts 
      
numopts = 0
options = ""
length = 0

do while .T.
   memvar = 'main_'+str(numopts+1,1)
   if TYPE('&memvar') = 'U'
      exit
   endif
   length = length + len(&memvar)
   options = options + UPPER(substr(&memvar,1,1))
   numopts = numopts+1
enddo

IF length > 70   && too many options or options too long &&
   * display error message or exit program
ENDIF

spaces = INT((79 - length)/numopts)

cur_opt = 1
cur_pos = 1
do while cur_opt <= numopts
   memvar = 'LOC_'+str(cur_opt,1)
   PUBLIC &memvar
   &memvar = cur_pos
   memvar2 = 'MAIN_'+str(cur_opt,1)

   cur_pos = cur_pos + LEN(&memvar2) + spaces
   cur_opt = cur_opt + 1
enddo

return



PROCEDURE setwins
* this sets up the window lengths according to the option variables you
* set up in the calling program

cur_win = 1
do while cur_win <= numopts
   memvar = 'loc_'+str(cur_win,1)
   left = &memvar
   top = 3
   cur_sub = 0
   maxlen = 0

   do while .t.
      memvar2 = 'opt'+str(cur_win,1)+'_'+str(cur_sub+1,1)
      if TYPE('&memvar2') = 'U'
         exit
      endif
      maxlen = MAX(LEN(&memvar2), maxlen)
      cur_sub = cur_sub + 1
   enddo

   right = left + (maxlen + 4)

   if (right >79)
      left = left - (right-79)
      right = 79
   endif

   bottom = top + cur_sub
   memvar = 'menu'+str(cur_win,1)
   w.set window &memvar to top,left,bottom,right DOUBLE
   cur_win = cur_win + 1
enddo

return


PROCEDURE prntmain
* this prints the main ring line
cur_opt = 1
clear
do while cur_opt <= numopts
   memvar = 'LOC_'+str(cur_opt,1)
   memvar2 = 'MAIN_'+str(cur_opt,1)
   @ 1,&memvar SAY &memvar2
   cur_opt = cur_opt + 1
enddo
@ 2,1 SAY REPLICATE(chr(223),78)

return



PROCEDURE getopt
* keeps looping until it gets a valid option or key pressed

do while .t.

   do prntopt

   ansrkey = inkey()
   do while ansrkey = 0
      ansrkey = inkey()
   enddo

   do case

   * cursor left pressed
   case ansrkey = 52 .and. cur_menu>'1'
      cur_menu = str((&cur_menu-1),1)
      cur_bar = 1
      w.close
      w.select 1
      store 'menu'+cur_menu TO win_name
      w.use &win_name

   * cursor right pressed
   case ansrkey = 54 .and. VAL(cur_menu)<numopts
      cur_menu = str((&cur_menu+1),1)
      cur_bar = 1
      w.close
      w.select 1
      store 'menu'+cur_menu TO win_name
      w.use &win_name   

   * cursor down pressed
   case ansrkey = 50 .and. cur_bar < numsubs-1
       cur_bar = cur_bar + 1

   * cursor up pressed
   case ansrkey = 56 .and. cur_bar > 1
       cur_bar = cur_bar - 1

   * first letter of an option pressed
   case UPPER(chr(ansrkey)) $ options
       cur_menu = str(AT(UPPER(chr(ansrkey)),options),1)
       cur_bar = 1
       w.close
       w.select 1
       store 'menu'+cur_menu to win_name
       w.use &win_name

   * carriage return - option selected
   case ansrkey = 13
       store cur_menu + str(cur_bar,1) TO choice
       return

   otherwise
       * this is an invalid option, just reprint menu
   endcase

enddo



PROCEDURE prntopt
* prints the window full of sub options
* highlights one depending on the value of cur_bar

store 1 to cur_opt
do while .t.
   store 'opt'+cur_menu+'_'+str(cur_opt,1) to opt_name
   if TYPE('&opt_name') = 'U'
      exit
   endif

   @ cur_opt-1,1 SAY &opt_name

   cur_opt = cur_opt + 1

enddo
store 'opt'+cur_menu+'_'+str(cur_bar,1) to opt_name
@ cur_bar-1,1 GET &opt_name
clear gets
numsubs = cur_opt
return



* END OF PROCEDURE MENUFNCT 

